## glewlwyd 2.7.1

=== CMakeLists.txt ===
#
# Glewlwyd
#
# CMake file used to build program
#
# Copyright 2016-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(glewlwyd C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROGRAM_VERSION_MAJOR "2")
set(PROGRAM_VERSION_MINOR "7")
set(PROGRAM_VERSION_PATCH "1")
set(PROJECT_DESCRIPTION "Single Sign On server, OAuth2, Openid Connect, multiple factor authentication with, HOTP/TOTP, FIDO2, TLS Certificates, etc. extensible via plugins ")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/glewlwyd/issues")
set(ORCANIA_VERSION_REQUIRED "2.3.0")
set(YDER_VERSION_REQUIRED "1.4.17")
set(ULFIUS_VERSION_REQUIRED "2.7.10")
set(HOEL_VERSION_REQUIRED "1.4.25")
set(RHONABWY_VERSION_REQUIRED "1.1.6")
set(IDDAWC_VERSION_REQUIRED "1.1.4")
set(LIBCBOR_VERSION_REQUIRED "0.5.0")
set(JANSSON_VERSION_REQUIRED "2.11")

set(USER_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/user/")
set(USER_MODULES "")

set(USER_MIDDLEWARE_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/user_middleware/")
set(USER_MIDDLEWARE_MODULES "")

set(CLIENT_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/client/")
set(CLIENT_MODULES "")

set(SCHEME_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/scheme/")
set(SCHEME_MODULES "")

set(PLUGIN_MODULES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/plugin/")
set(PLUGIN_MODULES "")

set(RESOURCES_SRC_PATH "${CMAKE_CURRENT_SOURCE_DIR}/docs/resources/ulfius/")

include(GNUInstallDirs)
include(CheckSymbolExists)

# cmake modules

set(G_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${G_CMAKE_MODULE_PATH}")

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
  check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

  if (NOT _GNU_SOURCE)
    unset(_GNU_SOURCE CACHE)
    check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
  endif ()
endif ()

if (_GNU_SOURCE)
  add_definitions(-D_GNU_SOURCE)
endif ()

set(GLWD_LIBS "-ldl -lcrypt")

find_package(Threads REQUIRED)
set(GLWD_LIBS ${GLWD_LIBS} ${CMAKE_THREAD_LIBS_INIT})

include(FindJansson)
find_package(Jansson ${JANSSON_VERSION_REQUIRED} REQUIRED)
if (JANSSON_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${JANSSON_LIBRARIES})
  include_directories(${JANSSON_INCLUDE_DIRS})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${GNUTLS_LIBRARIES})
  include_directories(${GNUTLS_INCLUDE_DIRS})
endif ()

include(FindNettle)
find_package(Nettle REQUIRED)
if (NETTLE_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${NETTLE_LIBRARIES})
  include_directories(${NETTLE_INCLUDE_DIRS})
endif ()

include(FindLibconfig)
find_package(Libconfig REQUIRED)
if (LIBCONFIG_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${LIBCONFIG_LIBRARIES})
  include_directories(${LIBCONFIG_INCLUDE_DIRS})
endif ()

include(FindMHD)
find_package(MHD REQUIRED)
if (MHD_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${MHD_LIBRARIES})
  include_directories(${MHD_INCLUDE_DIRS})
endif ()

include(FindZLIB)
find_package(ZLIB REQUIRED)
if (ZLIB_FOUND)
  set(GLWD_LIBS ${GLWD_LIBS} ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
endif ()

# build

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
add_executable(glewlwyd ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/static_compressed_inmemory_website_callback.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/http_compression_callback.h
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/client.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/module.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/plugin.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/scope.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/session.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/static_compressed_inmemory_website_callback.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/http_compression_callback.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/user.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/api_key.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/misc_config.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/metrics.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/webservice.c
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd.c )

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during orcania search and download
set(SEARCH_YDER OFF CACHE BOOL "Force to false") # Avoid to search and download yder during ulfius and hoel search and download

set(SEARCH_ORCANIA_U OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during ulfius search and download
set(BUILD_UWSC OFF CACHE BOOL "Force to false") # Avoid to build uwsc during ulfius search and download

set(SEARCH_ORCANIA_H OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during hoel search and download

set(SEARCH_ORCANIA_R OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during hoel search and download
set(SEARCH_YDER_R OFF CACHE BOOL "Force to false") # Avoid to search and download yder during ulfius and hoel search and download
set(SEARCH_ULFIUS_R OFF CACHE BOOL "Force to false") # Avoid to search and download ulfius during rhonabwy search and download

set(SEARCH_ORCANIA_I OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during iddawc search and download
set(SEARCH_YDER_I OFF CACHE BOOL "Force to false") # Avoid to search and download yder during iddawc search and download
set(SEARCH_ULFIUS_I OFF CACHE BOOL "Force to false") # Avoid to search and download ulfius during iddawc search and download
set(SEARCH_RHONABWY_I OFF CACHE BOOL "Force to false") # Avoid to search and download rhonabwy during iddawc search and download

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
include(FindOrcania)
find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
if (ORCANIA_FOUND)
  include_directories(${orcania_SOURCE_DIR}/include)
elseif (NOT ORCANIA_FOUND AND DOWNLOAD_DEPENDENCIES)
  include(DownloadProject)
  message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
  download_project(PROJ orcania # ... otherwise, download archive
      URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
      QUIET)
  add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
  include_directories(${orcania_SOURCE_DIR}/include)
  add_dependencies(glewlwyd orcania)
  set(ORCANIA_LIBRARIES orcania)
  include_directories(${orcania_BINARY_DIR})
else ()
  message( FATAL_ERROR "Orcania not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${ORCANIA_LIBRARIES})

set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
include(FindYder)
find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
if (YDER_FOUND)
  include_directories(${yder_SOURCE_DIR}/include)
elseif (NOT YDER_FOUND AND DOWNLOAD_DEPENDENCIES)
  include(DownloadProject)
  message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
  option(CHECK_ORCANIA "specific param" off)
  download_project(PROJ yder # ... otherwise, download archive
      URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
      QUIET)
  add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
  include_directories(${yder_SOURCE_DIR}/include)
  include_directories(${orcania_SOURCE_DIR}/include)
  add_dependencies(glewlwyd yder)
  add_dependencies(yder orcania)
  set(YDER_LIBRARIES yder)
  include_directories(${yder_BINARY_DIR})
else ()
  message( FATAL_ERROR "Yder not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${YDER_LIBRARIES})

set(Ulfius_FIND_QUIETLY ON)
include(FindUlfius)
find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} QUIET)
if (ULFIUS_FOUND)
  include_directories(${ulfius_SOURCE_DIR}/include)
elseif (NOT ULFIUS_FOUND AND DOWNLOAD_DEPENDENCIES)
  include(DownloadProject)
  option(WITH_WEBSOCKET "specific param" off)
  option(INSTALL_HEADER "specific param" off)
  option(CHECK_YDER "specific param" off)
  message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
  download_project(PROJ ulfius
      URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
      QUIET)
  add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
  include_directories(${yder_SOURCE_DIR}/include)
  include_directories(${orcania_SOURCE_DIR}/include)
  include_directories(${ulfius_SOURCE_DIR}/include)
  add_dependencies(glewlwyd ulfius)
  add_dependencies(ulfius yder)
  add_dependencies(ulfius orcania)
  set(ULFIUS_LIBRARIES ulfius)
  include_directories(${ulfius_BINARY_DIR})
else ()
  message( FATAL_ERROR "Ulfius not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${ULFIUS_LIBRARIES})

set(Hoel_FIND_QUIETLY ON)
include(FindHoel)
find_package(Hoel ${HOEL_VERSION_REQUIRED} QUIET)
if (HOEL_FOUND)
  include_directories(${hoel_SOURCE_DIR}/include)
elseif (NOT HOEL_FOUND AND DOWNLOAD_DEPENDENCIES)
  include(DownloadProject)
  option(INSTALL_HEADER "specific param" off)
  option(CHECK_YDER "specific param" off)
  message(STATUS "Download Hoel ${HOEL_VERSION_REQUIRED}")
  download_project(PROJ hoel
      URL "https://github.com/babelouest/hoel/archive/v${HOEL_VERSION_REQUIRED}.tar.gz"
      QUIET)
  add_subdirectory(${hoel_SOURCE_DIR} ${hoel_BINARY_DIR})
  include_directories(${hoel_SOURCE_DIR}/include)
  add_dependencies(glewlwyd hoel)
  add_dependencies(hoel yder)
  add_dependencies(hoel orcania)
  set(HOEL_LIBRARIES hoel)
  include_directories(${hoel_BINARY_DIR})
else ()
  message( FATAL_ERROR "Hoel not found")
endif ()
set(GLWD_LIBS ${GLWD_LIBS} ${HOEL_LIBRARIES})

target_link_libraries(glewlwyd ${GLWD_LIBS})

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.4)")

execute_process(COMMAND lsb_release -is
    OUTPUT_VARIABLE DISTRIB_CODENAME_T
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
string( TOLOWER "${DISTRIB_CODENAME_T}" DISTRIB_CODENAME )

execute_process(COMMAND lsb_release -cs
    OUTPUT_VARIABLE RELEASE_CODENAME_T
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
string( TOLOWER "${RELEASE_CODENAME_T}" RELEASE_CODENAME )

option(WITH_MOCK "Build Mock modules" off)

# user modules

if (WITH_MOCK OR BUILD_GLEWLWYD_TESTING)
  set(MOCK_LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MODULES_SRC_PATH}/mock.c)

  add_library(usermodmock MODULE ${MOCK_LIB_SRC})
  set_target_properties(usermodmock PROPERTIES
      COMPILE_OPTIONS -Wextra
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user")
  target_link_libraries(usermodmock ${GLWD_LIBS})
  set(USER_MODULES ${USER_MODULES} usermodmock)
endif ()

option(WITH_USER_DATABASE "Build Database backend user module" on)
if (WITH_USER_DATABASE)
  set(LIB_SRC ${CMAKE_CURRENT_SOURCE_DIR}/src/glewlwyd-common.h ${CMAKE_CURRENT_SOURCE_DIR}/src/misc.c ${USER_MODULES_SRC_PATH}/database.c)

  add_library(usermoddatabase MODULE ${LIB_SRC})
  set_target_properties(usermoddatabase PROPERTIES
      COMPILE_OPTIONS -Wextra
      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/user")
  target_link_libraries(usermoddatabase ${GLWD_LIBS})
  set(USER_MODULES ${USER_MODULES} usermoddatabase)
endif ()

option(WITH_USER_LDAP "Build LDAP backend user module" on)
if (WITH_USER_LDAP)
  include(FindLdap)
  find_package(Ldap REQUIRED)
  if (LDAP_FOUND)
    include_directories(${LDAP_INCLUDE_DIRS})
  endif ()

=== test/Makefile ===
#
# Glewlwyd SSO
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
LDFLAGS=-lc $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs libhoel) $(shell pkg-config --libs librhonabwy) $(shell pkg-config --libs libiddawc) $(shell pkg-config --libs jansson) $(shell pkg-config --libs check) $(shell pkg-config --libs gnutls) $(shell pkg-config --libs liboath) $(shell pkg-config --libs libcbor) -lpthread -lcbor
TARGET_ADMIN=glewlwyd_admin_mod_type glewlwyd_admin_mod_user glewlwyd_admin_mod_user_auth_scheme glewlwyd_admin_mod_client glewlwyd_admin_mod_plugin glewlwyd_admin_check_scope glewlwyd_admin_api_key glewlwyd_admin_mod_user_middleware
TARGET_AUTH=glewlwyd_auth_password glewlwyd_auth_scheme glewlwyd_auth_grant glewlwyd_auth_check_scheme glewlwyd_auth_scheme_trigger glewlwyd_auth_scheme_register glewlwyd_auth_profile glewlwyd_auth_session_manage glewlwyd_auth_profile_get_scheme_available glewlwyd_auth_profile_impersonate glewlwyd_scheme_forbidden glewlwyd_mail_on_connection glewlwyd_mail_on_scheme_register glewlwyd_mail_on_update_password
TARGET_CRUD=glewlwyd_crud_user glewlwyd_crud_client glewlwyd_crud_scope glewlwyd_crud_user_middleware glewlwyd_crud_misc_config
TARGET_OAUTH2=glewlwyd_oauth2_auth_code glewlwyd_oauth2_code glewlwyd_oauth2_code_client_confidential glewlwyd_oauth2_implicit glewlwyd_oauth2_resource_owner_pwd_cred glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential glewlwyd_oauth2_client_cred glewlwyd_oauth2_refresh_token glewlwyd_oauth2_refresh_token_client_confidential glewlwyd_oauth2_delete_token glewlwyd_oauth2_delete_token_client_confidential glewlwyd_oauth2_profile glewlwyd_oauth2_refresh_manage glewlwyd_oauth2_refresh_manage_session glewlwyd_oauth2_profile_impersonate glewlwyd_oauth2_additional_parameters glewlwyd_oauth2_client_secret glewlwyd_oauth2_code_challenge glewlwyd_oauth2_token_introspection glewlwyd_oauth2_token_revocation glewlwyd_oauth2_device_authorization glewlwyd_oauth2_code_replay glewlwyd_oauth2_scheme_required
TARGET_OIDC=glewlwyd_oidc_auth_code glewlwyd_oidc_code glewlwyd_oidc_code_client_confidential glewlwyd_oidc_token glewlwyd_oidc_resource_owner_pwd_cred glewlwyd_oidc_resource_owner_pwd_cred_client_confidential glewlwyd_oidc_client_cred glewlwyd_oidc_code_idtoken glewlwyd_oidc_implicit_id_token_token glewlwyd_oidc_implicit_none glewlwyd_oidc_hybrid_id_token_token_code glewlwyd_oidc_hybrid_id_token_code glewlwyd_oidc_hybrid_token_code glewlwyd_oidc_implicit_id_token glewlwyd_oidc_optional_request_parameters glewlwyd_oidc_refresh_token glewlwyd_oidc_refresh_token_client_confidential glewlwyd_oidc_delete_token glewlwyd_oidc_delete_token_client_confidential glewlwyd_oidc_refresh_manage glewlwyd_oidc_refresh_manage_session glewlwyd_oidc_userinfo glewlwyd_oidc_additional_parameters glewlwyd_oidc_only_no_refresh glewlwyd_oidc_discovery glewlwyd_oidc_client_secret glewlwyd_oidc_request_jwt glewlwyd_oidc_subject_type glewlwyd_oidc_address_claim glewlwyd_oidc_claims_scopes glewlwyd_oidc_claim_request glewlwyd_oidc_code_challenge glewlwyd_oidc_token_introspection glewlwyd_oidc_token_revocation glewlwyd_oidc_client_registration glewlwyd_oidc_jwt_encrypted glewlwyd_oidc_jwks_config glewlwyd_oidc_session_management glewlwyd_oidc_device_authorization glewlwyd_oidc_refresh_token_one_use glewlwyd_oidc_client_registration_management glewlwyd_oidc_code_replay glewlwyd_oidc_scheme_required glewlwyd_oidc_dpop glewlwyd_oidc_resource glewlwyd_oidc_rich_auth_requests glewlwyd_oidc_pushed_auth_requests glewlwyd_oidc_reduced_scope glewlwyd_oidc_all_algs glewlwyd_oidc_ciba glewlwyd_oidc_auth_iss_is glewlwyd_oidc_jarm glewlwyd_oidc_fapi
TARGET_REGISTER=glewlwyd_register
TARGET_IRL=glewlwyd_mod_user_irl glewlwyd_mod_client_irl glewlwyd_mod_user_multiple_password_irl glewlwyd_mod_user_http glewlwyd_oauth2_irl glewlwyd_oidc_irl glewlwyd_scheme_mail glewlwyd_scheme_otp glewlwyd_scheme_webauthn glewlwyd_scheme_retype_password glewlwyd_scheme_http glewlwyd_scheme_oauth2 glewlwyd_geolocation
TARGET_CERTIFICATE=glewlwyd_scheme_certificate glewlwyd_oidc_client_certificate
TARGET_PROFILE_DELETE=glewlwyd_profile_delete
TARGET_PROMETHEUS=glewlwyd_prometheus
VERBOSE=0
MEMCHECK=0
RUN=1
PARAM_FILE=param.json
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all
CERT=cert

all: test $(CERT)/server.key

clean:
	rm -f *.o *.log valgrind.txt valgrind-*.txt $(TARGET_ADMIN) $(TARGET_AUTH) $(TARGET_CRUD) $(TARGET_OAUTH2) $(TARGET_OIDC) $(TARGET_IRL) $(TARGET_CERTIFICATE) $(TARGET_REGISTER) $(TARGET_PROFILE_DELETE) $(TARGET_PROMETHEUS)
	rm -f $(CERT)/server.* $(CERT)/root* $(CERT)/client* $(CERT)/user* $(CERT)/packed* $(CERT)/apple* $(CERT)/certtool.log

$(CERT)/server.key:
	./$(CERT)/create-cert.sh

build: $(TARGET_ADMIN) $(TARGET_AUTH) $(TARGET_CRUD) $(TARGET_OAUTH2) $(TARGET_OIDC) $(TARGET_IRL) $(TARGET_CERTIFICATE) $(TARGET_REGISTER) $(TARGET_PROFILE_DELETE) $(TARGET_PROMETHEUS) $(CERT)/server.key

unit-tests.o: unit-tests.c unit-tests.h
	$(CC) $(CFLAGS) -c unit-tests.c

%: %.c unit-tests.o
	$(CC) $(CFLAGS) $^ -o $@ $(LDFLAGS)

test: build test-admin test-auth test-crud test-oauth2 test-oidc test-irl test-register test-profile-delete

test-auth: $(TARGET_AUTH) test_glewlwyd_auth_password test_glewlwyd_auth_scheme test_glewlwyd_auth_grant test_glewlwyd_auth_check_scheme test_glewlwyd_auth_scheme_trigger test_glewlwyd_auth_scheme_register test_glewlwyd_auth_profile test_glewlwyd_auth_session_manage test_glewlwyd_auth_profile_get_scheme_available test_glewlwyd_auth_profile_impersonate test_glewlwyd_scheme_forbidden test_glewlwyd_mail_on_connection test_glewlwyd_mail_on_scheme_register test_glewlwyd_mail_on_update_password

test-admin: $(TARGET_ADMIN) test_glewlwyd_admin_mod_type test_glewlwyd_admin_mod_user test_glewlwyd_admin_mod_user_auth_scheme test_glewlwyd_admin_mod_client test_glewlwyd_admin_mod_plugin test_glewlwyd_admin_check_scope test_glewlwyd_admin_api_key test_glewlwyd_admin_mod_user_middleware

test-crud: $(TARGET_CRUD) test_glewlwyd_crud_user test_glewlwyd_crud_client test_glewlwyd_crud_scope test_glewlwyd_crud_user_middleware test_glewlwyd_crud_misc_config

test-oauth2: $(TARGET_OAUTH2) test_glewlwyd_oauth2_auth_code test_glewlwyd_oauth2_code test_glewlwyd_oauth2_code_client_confidential test_glewlwyd_oauth2_implicit test_glewlwyd_oauth2_resource_owner_pwd_cred test_glewlwyd_oauth2_resource_owner_pwd_cred_client_confidential test_glewlwyd_oauth2_client_cred test_glewlwyd_oauth2_refresh_token test_glewlwyd_oauth2_refresh_token_client_confidential test_glewlwyd_oauth2_delete_token test_glewlwyd_oauth2_delete_token_client_confidential test_glewlwyd_oauth2_profile test_glewlwyd_oauth2_refresh_manage test_glewlwyd_oauth2_refresh_manage test_glewlwyd_oauth2_refresh_manage_session test_glewlwyd_oauth2_profile_impersonate test_glewlwyd_oauth2_additional_parameters test_glewlwyd_oauth2_client_secret test_glewlwyd_oauth2_code_challenge test_glewlwyd_oauth2_token_introspection test_glewlwyd_oauth2_token_revocation test_glewlwyd_oauth2_device_authorization test_glewlwyd_oauth2_code_replay test_glewlwyd_oauth2_scheme_required

test-oidc: $(TARGET_OIDC) $(CERT)/server.key test_glewlwyd_oidc_auth_code test_glewlwyd_oidc_code test_glewlwyd_oidc_code_client_confidential test_glewlwyd_oidc_token test_glewlwyd_oidc_resource_owner_pwd_cred test_glewlwyd_oidc_resource_owner_pwd_cred_client_confidential test_glewlwyd_oidc_client_cred test_glewlwyd_oidc_code_idtoken test_glewlwyd_oidc_implicit_id_token_token test_glewlwyd_oidc_implicit_id_token test_glewlwyd_oidc_implicit_none test_glewlwyd_oidc_hybrid_id_token_token_code test_glewlwyd_oidc_hybrid_token_code test_glewlwyd_oidc_hybrid_id_token_code test_glewlwyd_oidc_optional_request_parameters test_glewlwyd_oidc_refresh_token test_glewlwyd_oidc_refresh_token_client_confidential test_glewlwyd_oidc_delete_token test_glewlwyd_oidc_delete_token_client_confidential test_glewlwyd_oidc_refresh_manage test_glewlwyd_oidc_refresh_manage test_glewlwyd_oidc_refresh_manage_session test_glewlwyd_oidc_userinfo test_glewlwyd_oidc_additional_parameters test_glewlwyd_oidc_only_no_refresh test_glewlwyd_oidc_discovery test_glewlwyd_oidc_client_secret test_glewlwyd_oidc_request_jwt test_glewlwyd_oidc_subject_type test_glewlwyd_oidc_address_claim test_glewlwyd_oidc_claims_scopes test_glewlwyd_oidc_claim_request test_glewlwyd_oidc_code_challenge test_glewlwyd_oidc_token_introspection test_glewlwyd_oidc_token_revocation test_glewlwyd_oidc_client_registration test_glewlwyd_oidc_jwt_encrypted test_glewlwyd_oidc_jwks_config test_glewlwyd_oidc_session_management test_glewlwyd_oidc_device_authorization test_glewlwyd_oidc_refresh_token_one_use test_glewlwyd_oidc_client_registration_management test_glewlwyd_oidc_code_replay test_glewlwyd_oidc_scheme_required test_glewlwyd_oidc_dpop test_glewlwyd_oidc_resource test_glewlwyd_oidc_rich_auth_requests test_glewlwyd_oidc_pushed_auth_requests test_glewlwyd_oidc_reduced_scope test_glewlwyd_oidc_all_algs test_glewlwyd_oidc_ciba test_glewlwyd_oidc_auth_iss_is test_glewlwyd_oidc_jarm test_glewlwyd_oidc_fapi

test-certificate: $(TARGET_CERTIFICATE) $(CERT)/server.key test_glewlwyd_scheme_certificate test_glewlwyd_oidc_client_certificate

test-register: $(TARGET_REGISTER) $(CERT)/server.key test_glewlwyd_register

test-profile-delete: $(TARGET_PROFILE_DELETE) test_glewlwyd_profile_delete

test-prometheus: $(TARGET_PROMETHEUS) test_glewlwyd_prometheus

test-irl: $(TARGET_IRL) $(CERT)/server.key test_glewlwyd_mod_user_http test_glewlwyd_scheme_http test_glewlwyd_scheme_mail test_glewlwyd_scheme_otp test_glewlwyd_scheme_webauthn test_glewlwyd_scheme_retype_password test_glewlwyd_scheme_oauth2 test_glewlwyd_geolocation
	@for JSON_FILE in mod_user_*.json; \
		do $(MAKE) test_glewlwyd_mod_user_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in mod_multiple_password_*.json; \
		do $(MAKE) test_glewlwyd_mod_user_multiple_password_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in mod_client_*.json; \
		do $(MAKE) test_glewlwyd_mod_client_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in plugin_oauth2_*.json; \
		do $(MAKE) test_glewlwyd_oauth2_irl PARAM_FILE=$$JSON_FILE $*; \
	done
	@for JSON_FILE in plugin_oidc_*.json; \
		do $(MAKE) test_glewlwyd_oidc_irl PARAM_FILE=$$JSON_FILE $*; \
	done

test_%_irl: %_irl
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		echo "Run $^ with file $(PARAM_FILE)"; \
		LD_LIBRARY_PATH=. ./run_test.sh ./$^ $(PARAM_FILE); \
		mv $^.log $^-$(PARAM_FILE).log; \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=. ./$^ $(PARAM_FILE); \
	else \
		CK_FORK=no LD_LIBRARY_PATH=. $(VALGRIND_COMMAND) ./$^ $(PARAM_FILE) 2>valgrind-$@.txt; \
	fi

test_%: %
	@if [ "$(VERBOSE)" = "0" ] && [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=. ./run_test.sh ./$^ $(PARAM); \
	elif [ "$(MEMCHECK)" = "0" ]; then \
		LD_LIBRARY_PATH=. ./$^ $(PARAM); \
	else \
		CK_FORK=no LD_LIBRARY_PATH=. $(VALGRIND_COMMAND) ./$^ $(PARAM) 2>valgrind-$@.txt; \
	fi

=== docs/docker/Makefile ===
GLEWLWYD_VERSION=$(shell curl -s https://api.github.com/repos/babelouest/glewlwyd/releases/latest | grep tag_name | cut -d '"' -f 4 | cut -c 2-)
ALPINE_VERSION=3.16.0

all: build

glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz:
	wget https://github.com/babelouest/glewlwyd/releases/download/v${GLEWLWYD_VERSION}/glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz

build: glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker build -t babelouest/glewlwyd:$(GLEWLWYD_VERSION) --build-arg GLEWLWYD_VERSION=$(GLEWLWYD_VERSION) --build-arg ALPINE_VERSION=$(ALPINE_VERSION) .
	docker tag babelouest/glewlwyd:$(GLEWLWYD_VERSION) babelouest/glewlwyd:latest

run:
	docker run --rm -it -p 4593:4593 babelouest/glewlwyd:latest

my-config:
	docker run --rm -it -p 4593:4593 -v $(shell pwd)/config:/etc/glewlwyd babelouest/glewlwyd

clean:
	rm -f glewlwyd-full_$(GLEWLWYD_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker rmi -f babelouest/glewlwyd:latest babelouest/glewlwyd:$(GLEWLWYD_VERSION)
	docker system prune -f

=== debian/changelog ===
glewlwyd (2.7.1-1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Pass "--openssl-legacy-provider" to nodejs when invoking
      webpack.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Jun 2022 17:01:04 -0700

glewlwyd (2.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sun, 05 Jun 2022 09:02:36 -0400

glewlwyd (2.7.0-3) unstable; urgency=medium

  * d/patches: fix build with webpack 5 (Closes: #1011519)
  * d/rules: avoid copying node packages to webapp-src/node_modules

 -- Nicolas Mora <babelouest@debian.org>  Wed, 25 May 2022 07:33:44 -0400

glewlwyd (2.7.0-2ubuntu2) kinetic; urgency=medium

  * No-change rebuild against liborcania2.3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 03 Jun 2022 20:50:50 +0000

glewlwyd (2.7.0-2ubuntu1) kinetic; urgency=medium

  * d/rules: Pass "--openssl-legacy-provider" to nodejs when invoking
    webpack.  (LP: #1974107)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 19 May 2022 22:12:04 -0400

glewlwyd (2.7.0-2) unstable; urgency=medium

  * d/glewlwyd-common.install: copy bootstrap, jquery, fork-awesome
    instead of linking it
  * debian/sql/install: Update sql init scripts
  * d/glewlwyd-debian.conf.properties: Update default properties

 -- Nicolas Mora <babelouest@debian.org>  Tue, 03 May 2022 07:21:10 -0400

glewlwyd (2.7.0-1) unstable; urgency=medium

  * New upstream release: Fix CVE-2022-29967
    static_compressed_inmemory_website_callback.c in Glewlwyd through
    2.6.2 allows directory traversal.
  * d/po/es.po: Update Spanish translation (Closes: #1008528)
  * d/config.json: update config.json with default from upstream
  * d/copyright: update years

 -- Nicolas Mora <babelouest@debian.org>  Sat, 30 Apr 2022 08:49:57 -0400

glewlwyd (2.6.2-1) unstable; urgency=medium

  * New upstream release
  * d/patches: remvove webauthn.patch
  * d/po/es.po: Add Spanish translation (Closes: #1003294)

 -- Nicolas Mora <babelouest@debian.org>  Sat, 19 Mar 2022 15:45:43 -0400

glewlwyd (2.6.1-2) unstable; urgency=medium

  * d/patches: possible buffer overflow during signature
      validation in webauthn assertion

 -- Nicolas Mora <babelouest@debian.org>  Thu, 17 Mar 2022 20:55:25 -0400

=== debian/control ===
Source: glewlwyd
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
         , Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
# Backend dependencies
             , pkg-config
             , po-debconf
             , libmicrohttpd-dev
             , libjansson-dev
             , libcurl4-gnutls-dev
             , libldap2-dev
             , libsqlite3-dev
             , libconfig-dev
             , libgnutls28-dev
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libhoel-dev
             , librhonabwy-dev
             , libiddawc-dev
             , liboath-dev
             , libcbor-dev
             , cmake
# Front-end dependencies
Build-Depends-Indep: nodejs
             , node-react
             , node-babel7
             , node-babel-loader
             , node-css-loader
             , node-i18next
             , node-i18next-browser-languagedetector
             , node-i18next-http-backend
             , node-qrcode-generator
             , webpack
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
Standards-Version: 4.6.0
Homepage: https://github.com/babelouest/glewlwyd
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
Rules-Requires-Root: no

Package: glewlwyd
Architecture: any
Depends: ${shlibs:Depends},
       , ${misc:Depends}
       , lsb-base (>=3.0-6)
       , glewlwyd-common
       , sqlite3
       , ucf
       , dbconfig-mysql | dbconfig-sqlite3 | dbconfig-pgsql | dbconfig-no-thanks,
Pre-Depends: ${misc:Pre-Depends}
Suggests: rnbyc
Description: Single-Sign-On server with multiple factor authentication
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers

Package: glewlwyd-common
Depends: ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Architecture: all
Multi-Arch: foreign
Description: Single-Sign-On server with multiple factor authentication - common files
 Authentication processus supported:
  - OAuth2
  - OpenID Connect
 .
 Allows users to authenticate via multiple factors:
  - Password
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - One-time password sent via e-mail
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 Users and clients can be stored and managed from various backends:
  - Database
  - LDAP service
  - HTTP Backend service providing Basic Authentication
 .
 Allows users to register a new account with the possibility to confirm their
 e-mail address or not. During the registration process, the new user may be
 expected to register their passwords, as well as other authentication factors:
  - One-time password (TOTP/HOTP)
  - Webauthn (Yubikey, Android devices)
  - TLS Certificate
  - External OAuth2/OIDC providers
 .
 This package contains the architecture independent files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_HARDENING=1

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	# add a fake empty file in webapp-src/output so dh_install will not fail
	mkdir webapp-src/output/ && touch webapp-src/output/admin.js
	# configure cmake build
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    -DDOWNLOAD_DEPENDENCIES=OFF \
	                    --no-warn-unused-cli

override_dh_auto_build-indep:
	# Build webapp
	cp /usr/share/javascript/jquery/jquery.min.js webapp-src/js/
	cp /usr/share/javascript/popper.js/umd/popper.min.js webapp-src/js/
	cp /usr/share/javascript/popper.js/umd/popper-utils.min.js webapp-src/js/
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.min.js webapp-src/js/
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.min.js.map webapp-src/js/
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css webapp-src/css/
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css.map webapp-src/css/
	cp /usr/share/fonts-fork-awesome/css/fork-awesome.css webapp-src/css/
	cp /usr/share/fonts-fork-awesome/css/v5-compat.css webapp-src/css/
	cp /usr/share/fonts/eot/fork-awesome/forkawesome-webfont.eot webapp-src/fonts/
	cp /usr/share/fonts/svg/fork-awesome/forkawesome-webfont.svg webapp-src/fonts/
	cp /usr/share/fonts/truetype/fork-awesome/forkawesome-webfont.ttf webapp-src/fonts/
	cp /usr/share/fonts/woff/fork-awesome/forkawesome-webfont.woff webapp-src/fonts/
	cp /usr/share/fonts/woff/fork-awesome/forkawesome-webfont.woff2 webapp-src/fonts/
	(export NODE_OPTIONS="$$NODE_OPTIONS --openssl-legacy-provider" && \
		cd webapp-src && webpack --config webpack.config.js)

override_dh_auto_install:
	echo "do nothing here"

override_dh_clean:
	dh_clean --
	rm -rf webapp-src/output

## glewlwyd 2.7.2

=== debian/changelog ===
glewlwyd (2.7.2-1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: Pass "--openssl-legacy-provider" to nodejs when invoking
      webpack.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 18 Jul 2022 21:23:14 -0700

glewlwyd (2.7.2-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update standards version to 4.6.1 (no change)

 -- Nicolas Mora <babelouest@debian.org>  Fri, 08 Jul 2022 07:17:21 -0400

=== debian/control ===
--- 
+++ 
@@ -40,7 +40,7 @@
              , libjs-jquery
              , libjs-bootstrap4
              , libjs-popper.js
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/babelouest/glewlwyd
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/glewlwyd.git
